﻿Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Ser.PortName = ComboBox1.SelectedItem
        Ser.Open()

        Dim Cmd1 As Byte() = {&HFE, &H44, &H0, &H8, &H2}
        AddCheckSum(Cmd1)
        While True
            Ser.DiscardInBuffer()
            Ser.Write(Cmd1, 0, Cmd1.Length)

            Dim timeOut As DateTime = Now
            While Ser.BytesToRead < 7
                Dim timePeriod As TimeSpan = Now() - timeOut
                If timePeriod > TimeSpan.FromMilliseconds(90) Then
                    Exit While
                End If
                System.Threading.Thread.Sleep(5)
            End While

            If Ser.BytesToRead >= 7 Then
                Dim TheResult(6) As Byte
                Ser.Read(TheResult, 0, 7)
                If ValidatePacket(TheResult) = True Then
                    Label4.Text = GetInteger(TheResult, 3)
                    Exit While
                End If
            End If
        End While

        Dim Cmd2 As Byte() = {&HFE, &H44, &H0, &H12, &H2}
        AddCheckSum(Cmd2)
        While True
            Ser.DiscardInBuffer()
            Ser.Write(Cmd2, 0, Cmd2.Length)

            Dim timeOut As DateTime = Now
            While Ser.BytesToRead < 7
                Dim timePeriod As TimeSpan = Now() - timeOut
                If timePeriod > TimeSpan.FromMilliseconds(90) Then
                    Exit While
                End If
                System.Threading.Thread.Sleep(5)
            End While

            If Ser.BytesToRead >= 7 Then
                Dim TheResult(6) As Byte
                Ser.Read(TheResult, 0, 7)
                If ValidatePacket(TheResult) = True Then
                    Label5.Text = GetInteger(TheResult, 3)
                    Exit While
                End If
            End If
        End While

        Dim Cmd3 As Byte() = {&HFE, &H44, &H0, &H14, &H2}
        AddCheckSum(Cmd3)
        While True
            Ser.DiscardInBuffer()
            Ser.Write(Cmd3, 0, Cmd3.Length)

            Dim timeOut As DateTime = Now
            While Ser.BytesToRead < 7
                Dim timePeriod As TimeSpan = Now() - timeOut
                If timePeriod > TimeSpan.FromMilliseconds(90) Then
                    Exit While
                End If
                System.Threading.Thread.Sleep(5)
            End While

            If Ser.BytesToRead >= 7 Then
                Dim TheResult(6) As Byte
                Ser.Read(TheResult, 0, 7)
                If ValidatePacket(TheResult) = True Then
                    Label6.Text = GetInteger(TheResult, 3)
                    Exit While
                End If
            End If
        End While
        Ser.Close()
    End Sub

    Protected Function GetInteger(ByRef Bytes() As Byte, ByRef Offset As Integer) As Int16
        Dim TempArray() As Byte = {Bytes(Offset + 1), Bytes(Offset)}
        Return BitConverter.ToInt16(TempArray, 0)
    End Function
    Private Function CRC16(ByVal MB_aray() As Byte, ByVal mNum As Integer) As Long
        Dim i As Long = 0
        Dim Temp As UInteger = 0
        Dim CRC As UInteger = 65535
        Dim j As Integer = 0
        For i = 0 To mNum - 1
            Temp = (CRC)
            CRC = Temp Xor (MB_aray(i))
            For j = 0 To 7
                If (CRC And 1) Then
                    CRC = ((CRC >> 1) Xor 40961) '&H1021&)
                Else
                    CRC = (CRC >> 1) 'And 65535
                End If
            Next j
        Next i
        CRC16 = CRC And 65535
    End Function

    Private Function ValidatePacket(ByVal Packet() As Byte) As Boolean
        Dim CRC As Integer = CRC16(Packet, Packet.Length - 2)
        Dim CRC_Compare As Integer = BitConverter.ToUInt16(Packet, Packet.Length - 2)
        If (CRC <> CRC_Compare) Then
            Return False
        Else
            Return True
        End If
    End Function

    Private Sub AddCheckSum(ByRef Packet() As Byte)
        Dim CRC() As Byte = BitConverter.GetBytes(CType(CRC16(Packet, Packet.Length), UInt16))
        Dim OutputArray(Packet.Length + 1) As Byte
        Packet.CopyTo(OutputArray, 0)
        CRC.CopyTo(OutputArray, Packet.Length)

        Packet = OutputArray
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        For Each Str As String In IO.Ports.SerialPort.GetPortNames
            ComboBox1.Items.Add(Str)
        Next
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Ser.PortName = ComboBox1.SelectedItem
        Ser.Open()

        Dim Cmd1 As Byte() = {&HFE, &H41, &H0, &H60, &H1, &H35}
        AddCheckSum(Cmd1)
        While True
            Ser.DiscardInBuffer()
            Ser.Write(Cmd1, 0, Cmd1.Length)

            Dim timeOut As DateTime = Now
            While Ser.BytesToRead < 4
                Dim timePeriod As TimeSpan = Now() - timeOut
                If timePeriod > TimeSpan.FromMilliseconds(90) Then
                    Exit While
                End If
                System.Threading.Thread.Sleep(5)
            End While

            If Ser.BytesToRead >= 4 Then
                Dim TheResult(3) As Byte
                Ser.Read(TheResult, 0, 4)
                If ValidatePacket(TheResult) = True Then
                    Exit While
                End If
            End If
        End While
        Ser.Close()
    End Sub
End Class
